/* global WCF_ADDONS_JS */
(function ($) {
    /**
     * @param $scope The Widget wrapper element as a jQuery element
     * @param $ The jQuery alias
     */

    const getSliderOptions = function ($scope) {
        const slider = $($('.cwt_donation_slider', $scope)[0]);
        console.log(slider)
        const sliderSettings = $($('.cwt_donation_slider_wrapper', $scope)[0]).data('settings') || {};
        sliderSettings.handleElementorBreakpoints = true;

        return {slider: slider, options: sliderSettings};
    }

    const CWTdonation = function ($scope, $) {
        if ($scope.find('.cwt--donation-slider').length) {
            const {slider, options} = getSliderOptions($scope);
            new elementorFrontend.utils.swiper(slider, options).then(newSwiperInstance => newSwiperInstance);
        }

        // Progress
        let repeater_content = $scope.find('.cwt--donation .cwt--donation-item .progress');
        repeater_content.each(function () {
            const percentage = $(this).attr('data-progress');
            $(this).css("--barWidth", percentage);
        });

        // Filtering
        const $buttons = $scope.find(".cwt--donation .filter button");
        const $items = $scope.find(".cwt--donation .cwt--donation-item");

        $buttons.on("click", function () {
            const filter = $(this).data("filter");
            $(this).addClass('active').siblings().removeClass('active');
            donationFilterItems(filter);
        });

        function donationFilterItems(filter) {
            const state = Flip.getState($items.toArray());

            $items.each(function () {
                const $item = $(this);
                if (filter === "all" || $item.hasClass(filter)) {
                    $item.show();
                } else {
                    $item.hide();
                }
            });

            Flip.from(state, {
                duration: 0.5,
                ease: "power1.inOut",
                stagger: 0.1,
            });
        }

    };


    // Make sure you run this code under Elementor.
    $(window).on('elementor/frontend/init', function () {
        elementorFrontend.hooks.addAction('frontend/element_ready/cwt--donation.default', CWTdonation);
    });
})(jQuery);
