(function ($) {
    /**
     * @param $scope The Widget wrapper element as a jQuery element
     * @param $ The jQuery alias
     */

    const Tabs = function ($scope) {
        
        //Default Action
        $('.tab-item', $scope).hide(); //Hide all content
        $('.tab-title:first', $scope).addClass("active").show();
        $('.tab-item:first', $scope).show();
        $('.tab-title .disc', $scope).hide();

        //mobile title
        const activeMobileTitle = $('.tab-title:first', $scope).attr("aria-controls");
        $(`.tab-title[aria-controls='${activeMobileTitle}']`, $scope).addClass("active");

        //On Click Event
        $('.tab-title', $scope).click(function () {

            if ($(this).hasClass("active")) {
                return;
            }

            $('.tab-title', $scope).removeClass("active");
            $(this).addClass("active");
            $('.tab-item', $scope).hide();
            const activeTab = $(this).attr("aria-controls");
            
            $(`.tab-item[id='${activeTab}']`, $scope).fadeIn();

            return false;
        });
    }

    // Make sure you run this code under Elementor.
    $(window).on('elementor/frontend/init', function () {
        elementorFrontend.hooks.addAction(`frontend/element_ready/helo--work-workprocess.default`, Tabs);
    });
})(jQuery);