/* global WCF_ADDONS_JS */
(function ($) {
    /**
     * @param $scope The Widget wrapper element as a jQuery element
     * @param $ The jQuery alias
     */

    const getSliderOptions = function ($scope) {
        const slider = $($('.helo_hero_slider', $scope)[0]);
        const sliderSettings = $($('.helo_hero_wrapper', $scope)[0]).data('settings') || {};
        sliderSettings.handleElementorBreakpoints = true

        //navigation
        if (sliderSettings.hasOwnProperty('navigation')) {
            const next = $('.wcf-arrow-next', $scope)[$('.wcf-arrow-next', $scope).length - 1]
            const prev = $('.wcf-arrow-prev', $scope)[$('.wcf-arrow-prev', $scope).length - 1]
            sliderSettings.navigation.nextEl = next;
            sliderSettings.navigation.prevEl = prev;
        }

        //pagination fractions
        if (sliderSettings.hasOwnProperty('pagination')) {
            sliderSettings.pagination.el = $('.swiper-pagination', $scope)[$('.swiper-pagination', $scope).length - 1];

            if (sliderSettings.pagination.hasOwnProperty('type') && 'fraction' === sliderSettings.pagination.type) {
                sliderSettings.pagination.formatFractionCurrent = function (number) {
                    return ('0' + number).slice(-2);
                }
                sliderSettings.pagination.formatFractionTotal = function (number) {
                    return ('0' + number).slice(-2);
                }
                sliderSettings.pagination.renderFraction = function (currentClass, totalClass) {
                    return '<span class="' + currentClass + '"></span>' +
                        '<span class="dash">/</span>' +
                        '<span class="' + totalClass + '"></span>';
                }
            }
        }

        //remove the attribute after getting the slider settings
        $($('.helo_hero_wrapper', $scope)[0]).removeAttr('data-settings');

        return {slider: slider, options: sliderSettings};

    }

    const HeloHeroSlider = function ($scope, $) {

        const {slider, options} = getSliderOptions($scope);
        const thumb_items = $('.thumb-item',$scope )

        new elementorFrontend.utils.swiper(slider, options).then(newSwiperInstance => {
            $(thumb_items[newSwiperInstance.activeIndex]).addClass('active');

            newSwiperInstance.on('slideChange', function (s){
                $(thumb_items).removeClass('active')
                $(thumb_items[s.activeIndex]).addClass('active')
            })

            return  newSwiperInstance
        });
    };


    // Make sure you run this code under Elementor.
    $(window).on('elementor/frontend/init', function () {
        elementorFrontend.hooks.addAction('frontend/element_ready/helo--hero-slider.default', HeloHeroSlider);
    });
})(jQuery);
