(function ($) {
    /**
     * @param $scope The Widget wrapper element as a jQuery element
     * @param $ The jQuery alias
     */

    var WCF_Side_Offcanvas = function ($scope, $) {
        const openBtn = $('.side--off-open');

        if (openBtn.length) {
            let off_canvas = openBtn.parent().siblings(".side--offcanvas");
            const copy_offcanvas = off_canvas.clone();
            off_canvas.remove();
            $('body').append(copy_offcanvas);

            const closeBtn = $('.side--off-close');

            openBtn.on('click', function () {
                const id = $(this).data('id')
                $(`.side--offcanvas[data-id|=${id}]`).addClass('show')
            })

            closeBtn.on('click', function () {
                $('.side--offcanvas').removeClass('show')
            })
        }
    };

    // Make sure you run this code under Elementor.
    $(window).on('elementor/frontend/init', function () {
        elementorFrontend.hooks.addAction('frontend/element_ready/wcf--side-offcanvas.default', WCF_Side_Offcanvas);
    });

})(jQuery);