<?php

namespace HeloEssentialApp\Inc;
use \Elementor\Controls_Manager;

class Helo_Section_Settings {

    public function __construct(){
        add_action( 'elementor/element/section/section_advanced/after_section_end', [ $this, 'add_controls_section' ],50);
        add_action( 'elementor/element/container/section_layout/after_section_end', [ $this, 'add_controls_section' ],50);
    }
    
    public function bottom_top_scroll( $element ) {
	
        $element->add_control(
			'wcf_enable_bottom_top_scroll',
			[
				'label'              => esc_html__( 'Enable ScrollTo', 'helo-essential' ),
				'type'               => \Elementor\Controls_Manager::SWITCHER,
				'label_on'           => esc_html__( 'Yes', 'helo-essential' ),
				'label_off'          => esc_html__( 'NO', 'helo-essential' ),
				'return_value'       => 'yes',
				'default'            => '',
				'frontend_available' => true,
			]
		);
		
    }

    public function add_controls_section( $element ){

        $element->start_controls_section(
            'wcf_isolation_custom_sticky_section',
            [
                'tab'           =>  \Elementor\Controls_Manager::TAB_ADVANCED,
                'label' => esc_html__( 'WCF Isolation', 'helo-essential' ),
            ]
        );

            $element->add_control(
                'wcf_pro_isolation_type',
                [
                    'label' => esc_html__( 'Isolation', 'helo-essential' ),
                    'type' => \Elementor\Controls_Manager::SELECT,
                    'default' => '',
                    'options' => [

                        'isolate'      => esc_html__( 'Isolate', 'helo-essential' ),
                        'revert'       => esc_html__( 'Revert', 'helo-essential' ),
                        'revert-layer' => esc_html__( 'Revert layer', 'helo-essential' ),
                        'auto'         => esc_html__( 'Auto', 'helo-essential' ),
                        'initial'      => esc_html__( 'Initial', 'helo-essential' ),
                        ''             => esc_html__( 'None', 'helo-essential' ),
                
                    ],
                    'selectors' => [
                        '{{WRAPPER}}' => 'isolation: {{VALUE}}',
                    ],
                ]
            );
 
        $element->end_controls_section();
        
    }

   
}

new Helo_Section_Settings();