<?php

// Woo a top-tab
CSF::createSection( HELO_OPTION_KEY, array(
	'id'    => 'wcf_woo_tab',                     // Set a unique slug-like ID
	'title' => esc_html__( 'WooCommerce', 'helo-essential' ),
	'icon'  => 'fas fa-archive',
) );

// Shop
CSF::createSection( HELO_OPTION_KEY, array(
	'parent' => 'wcf_woo_tab',                        // The slug id of the parent section
	'icon'   => 'fas fa-archive',
	'title'  => esc_html__( 'Shop', 'helo-essential' ),
	'fields' => array(
		array(
			'id'          => 'wcf_woo_sidebar',
			'type'        => 'select',
			'title'       => esc_html__( 'Shop Sidebar', 'helo-essential' ),
			'placeholder' => 'Select an option',
			'options'     => array(
				'no-sidebar'    => esc_html__( 'No sidebar', 'helo-essential' ),
				'left-sidebar'  => esc_html__( 'Left Sidebar', 'helo-essential' ),
				'right-sidebar' => esc_html__( 'Right Sidebar', 'helo-essential' ),
			),
			'default'     => 'left-sidebar',
		),

		array(
			'id'          => 'wcf_woo_product_sidebar',
			'type'        => 'select',
			'title'       => esc_html__( 'Product Sidebar', 'helo-essential' ),
			'placeholder' => 'Select an option',
			'options'     => array(
				'no-sidebar'    => esc_html__( 'No sidebar', 'helo-essential' ),
				'left-sidebar'  => esc_html__( 'Left Sidebar', 'helo-essential' ),
				'right-sidebar' => esc_html__( 'Right Sidebar', 'helo-essential' ),
			),
			'default'     => 'no-sidebar',
		),

		array(
			'id'          => 'wcf_product_cols',
			'type'        => 'select',
			'title'       => esc_html__( 'Product Columns', 'helo-essential' ),
			'placeholder' => 'Select Columns',
			'options'     => array(
				'2' => esc_html__( '2', 'helo-essential' ),
				'3' => esc_html__( '3', 'helo-essential' ),
				'4' => esc_html__( '4', 'helo-essential' ),
			),
			'default'     => '3',
		),

		array(
			'id'          => 'wcf_product_tb_cols',
			'type'        => 'select',
			'title'       => esc_html__( 'Product Columns in Tablet', 'helo-essential' ),
			'placeholder' => 'Select Columns',
			'options'     => array(
				'1' => esc_html__( '1', 'helo-essential' ),
				'2' => esc_html__( '2', 'helo-essential' ),
				'3' => esc_html__( '3', 'helo-essential' ),
			),
			'default'     => '2',
		),

		array(
			'id'          => 'wcf_rel_product_cols',
			'type'        => 'select',
			'title'       => esc_html__( 'Related Product Show', 'helo-essential' ),
			'placeholder' => 'Select Columns',
			'options'     => array(
				'2' => esc_html__( '2', 'helo-essential' ),
				'3' => esc_html__( '3', 'helo-essential' ),
				'4' => esc_html__( '4', 'helo-essential' ),
				'5' => esc_html__( '5', 'helo-essential' ),
				'6' => esc_html__( '6', 'helo-essential' ),
			),
			'default'     => '4',
		),

		array(
			'id'          => 'wcf_shop_thumb_size',
			'type'        => 'select',
			'title'       => esc_html__( 'Image Size', 'helo-essential' ),
			'placeholder' => esc_html__( 'Select Product Thumbsize', 'helo-essential' ),
			'options'     => helo_get_image_sizes(),
			'default'     => 'full',
		),


	)
) );


// Sidebar
CSF::createSection( HELO_OPTION_KEY, array(
	'parent' => 'wcf_woo_tab',                        // The slug id of the parent section
	'icon'   => 'fas fa-archive',
	'title'  => esc_html__( 'Sidebar', 'helo-essential' ),
	'fields' => array(
		array(
			'id'     => 'wcf_s_title_color',
			'type'   => 'color',
			'title'  => esc_html__( 'Title Color', 'helo-essential' ),
			'output' => '.wcf-woo--title',
		),

		array(
			'id'          => 'wcf_s_title_border',
			'type'        => 'color',
			'title'       => esc_html__( 'Border Color', 'helo-essential' ),
			'output_mode' => 'border-color',
			'output'      => '.wcf-woo--title',
		),

		array(
			'id'          => 'wcf_s_widget_b_radius',
			'type'        => 'spacing',
			'title'       => 'Border Radius',
			'output_mode' => 'border-radius',
			'output'      => '.wcf-woo--widget',
		),

		array(
			'id'          => 'wcf_s_widget_bg',
			'type'        => 'color',
			'title'       => esc_html__( 'Background Color', 'helo-essential' ),
			'output_mode' => 'background-color',
			'output'      => '.wcf-woo--widget',
		),

	)
) );


// Cart
CSF::createSection( HELO_OPTION_KEY, array(
	'parent' => 'wcf_woo_tab',                        // The slug id of the parent section
	'icon'   => 'fas fa-archive',
	'title'  => esc_html__( 'Cart', 'helo-essential' ),
	'fields' => array(

		array(
			'id'    => 'cart_uwq_change',
			'type'  => 'switcher',
			'title' => 'Update Cart with Quantity',
		),

		array(
			'id'          => 'onsale_color',
			'type'        => 'color',
			'title'       => esc_html__( 'Onsale Color', 'helo-essential' ),
			'output' => array( '.woocommerce ul.products li.product .onsale', '.single-product.woocommerce span.onsale' ),
		),

		array(
			'id'          => 'onsale_bg_color',
			'type'        => 'color',
			'title'       => esc_html__( 'Onsale Background Color', 'helo-essential' ),
			'output_mode' => 'background-color',
			'output' => array( '.woocommerce ul.products li.product .onsale', '.single-product.woocommerce span.onsale' ),
		),

	)
) );


// Message
CSF::createSection( HELO_OPTION_KEY, array(
	'parent' => 'wcf_woo_tab',                        // The slug id of the parent section
	'icon'   => 'fas fa-archive',
	'title'  => esc_html__( 'Error & Message', 'helo-essential' ),
	'fields' => array(
		array(
			'id'            => 'opt-tabbed-banner',
			'type'          => 'tabbed',
			'title'         => 'Style',
			'tabs'          => array(

				array(
					'title'     => esc_html__('Message','helo-essential'),
					'icon'      => '',
					'fields'    => array(
						array(
							'id'          => 'woo_msg_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Color', 'helo-essential' ),
							'output'      => '.woocommerce-message',
						),

						array(
							'id'          => 'woo_msg_b_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Border Color', 'helo-essential' ),
							'output_mode' => 'border-top-color',
							'output'      => '.woocommerce-message',
						),

						array(
							'id'          => 'woo_msg_icon_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Icon Color', 'helo-essential' ),
							'output'      => '.woocommerce-message::before',
						),

						array(
							'id'          => 'woo_msg_bg',
							'type'        => 'color',
							'title'       => esc_html__( 'Background Color', 'helo-essential' ),
							'output_mode' => 'background-color',
							'output'      => '.woocommerce-message',
						),

					)
				),

				array(
					'title'     => esc_html__('Info','helo-essential'),
					'icon'      => '',
					'fields'    => array(

						array(
							'id'          => 'woo_info_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Color', 'helo-essential' ),
							'output'      => '.woocommerce-info',
						),

						array(
							'id'          => 'woo_info_b_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Border Color', 'helo-essential' ),
							'output_mode' => 'border-top-color',
							'output'      => '.woocommerce-info',
						),

						array(
							'id'          => 'woo_info_icon_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Icon Color', 'helo-essential' ),
							'output'      => '.woocommerce-info::before',
						),

						array(
							'id'          => 'woo_info_msg_bg',
							'type'        => 'color',
							'title'       => esc_html__( 'Background Color', 'helo-essential' ),
							'output_mode' => 'background-color',
							'output'      => '.woocommerce-info',
						),

					)
				),

				array(
					'title'     => esc_html__('Error','helo-essential'),
					'icon'      => '',
					'fields'    => array(
						array(
							'id'          => 'woo_err_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Color', 'helo-essential' ),
							'output'      => '.woocommerce-error',
						),

						array(
							'id'          => 'woo_err_b_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Border Color', 'helo-essential' ),
							'output_mode' => 'border-top-color',
							'output'      => '.woocommerce-error',
						),

						array(
							'id'          => 'woo_err_icon_color',
							'type'        => 'color',
							'title'       => esc_html__( 'Icon Color', 'helo-essential' ),
							'output'      => '.woocommerce-error::before',
						),

						array(
							'id'          => 'woo_err_msg_bg',
							'type'        => 'color',
							'title'       => esc_html__( 'Background Color', 'helo-essential' ),
							'output_mode' => 'background-color',
							'output'      => '.woocommerce-error',
						),
					)
				),

			)
		),
	)
) );