<?php
namespace HeloEssentialApp\Importer;
use Elementor\Plugin;
/**
 * demo import.
 */
class Wcf_Theme_Demos
{
	public $_metas = array(
		'helo_lic_Key',
		'helo_lic_email',
		'helo_license_key_status',
	);
	/**
	 * register default hooks and actions for WordPress
	 * @return
	 */
	public function __construct()
	{
		add_action( 'fw:ext:backups:tasks:success', [$this,'success'] );

		if(!helo_theme_service_pass()){
			return;
		}

		add_filter( 'fw:ext:backups-demo:demos', [$this,'backups_demos'] );

	}

	function backups_demos( $demos ) {

		$demo_content_installer	 = 'https://themecrowdy.com/demo-content/helo';

		$demos_array			 = array(

			'fashion-model-agency' => array(
				'title'        => esc_html__( 'Fashion Agency', 'helo-essential' ),
				'category'     => ['Fashion','Creative Agency'],
				'screenshot'   => esc_url( $demo_content_installer ) . '/fashion-model-agency/sc.webp',
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/fashion-model-agency/' ),
			),

			'design-studio' => array(
				'title'        => esc_html__( 'Design Studio', 'helo-essential' ),
				'category'     => ['Fashion','Creative Agency'],
				'screenshot'   => esc_url( $demo_content_installer ) . '/design-studio/sc.webp',
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/design-studio/' ),
			),

			'creative-branding-agency' => array(
				'title'        => esc_html__( 'Creative Branding Agency', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/creative-branding-agency/sc.webp',
				'category'     => ['Creative Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/creative-branding-agency/' ),
			),

			'creative-agency' => array(
				'title'        => esc_html__( 'Creative Agency', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/creative-agency/sc.webp',
				'category'     => ['Creative Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/creative-agency/' ),
			),

			'digital-agency' => array(
				'title'        => esc_html__( 'Digital Agency', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/digital-agency/sc.webp',
				'category'     => ['Creative Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/digital-agency/' ),
			),

			'fashion-designer' => array(
				'title'        => esc_html__( 'Fashion Designer', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/fashion-designer/sc.webp',
				'category'     => [ 'Fashion'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/fashion-designer/' ),
			),

			'writer' => array(
				'title'        => esc_html__( 'Writer', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/writer/sc.webp',
				'category'     => [ 'Writer', 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/writer/' ),
			),

			'chef' => array(
				'title'        => esc_html__( 'Chef', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/chef/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/chef/' ),
			),

			'artist' => array(
				'title'        => esc_html__( 'Artist', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/artist/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/artist/' ),
			),

			'interior-designer' => array(
				'title'        => esc_html__( 'Interior Designer', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/interior-designer/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/interior-designer/' ),
			),

			'dancer' => array(
				'title'        => esc_html__( 'Dancer', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/dancer/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/dancer/' ),
			),

			'barber' => array(
				'title'        => esc_html__( 'Barber', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/barber/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/barber/' ),
			),

			'yoga-trainer' => array(
				'title'        => esc_html__( 'Yoga Trainer', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/yoga-trainer/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/yoga-trainer/' ),
			),

			'startup' => array(
				'title'        => esc_html__( 'Startup', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/startup/sc.webp',
				'category'     => [ 'Business', 'Agency' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/startup/' ),
			),

			'athlete' => array(
				'title'        => esc_html__( 'Athlete', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/athlete/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/athlete/' ),
			),

			'dentist' => array(
				'title'        => esc_html__( 'Dentist', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/dentist/sc.webp',
				'category'     => [ 'Personal' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/dentist/' ),
			),

			'solar-system' => array(
				'title'        => esc_html__( 'Solar System', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/solar-system/sc.webp',
				'category'     => [ 'Corporate' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/solar-services/' ),
			),

			'computer-phone' => array(
				'title'        => esc_html__( 'Compurter & Phone Repair', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/computer-phone/sc.webp',
				'category'     => [ 'Corporate' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/computer-phone/' ),
			),

			'marketing-automation' => array(
				'title'        => esc_html__( 'Marketing Automation', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/marketing-automation/sc.webp',
				'category'     => [ 'Corporate','Business' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/marketing-automation/' ),
			),

			'booking-software' => array(
				'title'        => esc_html__( 'Booking Software', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/booking-software/sc.webp',
				'category'     => [ 'Corporate','Business' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/booking-software/' ),
			),


			'ai-software' => array(
				'title'        => esc_html__( 'AI Software', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/ai-software/sc.webp',
				'category'     => [ 'Corporate','Business' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/ai-software/' ),
			),

			'startup-agency' => array(
				'title'        => esc_html__( 'Startup Agency', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/startup-agency/sc.webp',
				'category'     => [ 'Corporate','Business', 'Agency' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/startup-agency/' ),
			),
			
			'customer-service' => array(
				'title'        => esc_html__( 'Customer Service', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/customer-service/sc.webp',
				'category'     => [ 'Corporate','Business' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/customer-service/' ),
			),

			'law-firm' => array(
				'title'        => esc_html__( 'Law Firm', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/law-firm/sc.webp',
				'category'     => [ 'Personal','Business' ],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/law-firm/' ),
			),

			'motivational-speaker' => array(
				'title'        => esc_html__( 'Motivational Speaker', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/motivational-speaker/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/motivational-speaker/' ),
			),

			'modern-interior-design' => array(
				'title'        => esc_html__( 'Modern Interior', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/modern-interior-design/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/modern-interior-design/' ),
			),

			'modern-architecture' => array(
				'title'        => esc_html__( 'Modern Architecture', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/modern-architecture/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/modern-architecture/' ),
			),

			'renovation' => array(
				'title'        => esc_html__( 'Renovation', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/renovation/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/renovation/' ),
			),

			'business-consultant' => array(
				'title'        => esc_html__( 'Business Consultant', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/business-consultant/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/business-consultant/' ),
			),

			'consultant-marketing' => array(
				'title'        => esc_html__( 'Consultant Marketing', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/consultant-marketing/sc.webp',
				'category'     => [ 'Business','Marketing'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/consultant-marketing/' ),
			),

			'corporate-agtency' => array(
				'title'        => esc_html__( 'Corporate Agency', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/corporate-agtency/sc.webp',
				'category'     => [ 'Business','Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/corporate/' ),
			),

			'hospital' => array(
				'title'        => esc_html__( 'Hospital', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/hospital/sc.webp',
				'category'     => [ 'Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/hospital/' ),
			),

			'hospital-2' => array(
				'title'        => esc_html__( 'Hospital Two', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/hospital-2/sc.webp',
				'category'     => [ 'Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/hospital-two/' ),
			),

			'doctor' => array(
				'title'        => esc_html__( 'Doctor', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/doctor/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/doctor/' ),
			),

			'architect' => array(
				'title'        => esc_html__( 'Architect', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/architect/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/architect/' ),
			),

			'social-influencer' => array(
				'title'        => esc_html__( 'Social Influencer', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/social-influencer/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/social-influencer/' ),
			),

			'electrician' => array(
				'title'        => esc_html__( 'Electrician', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/electrician/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/electrician/' ),
			),

			'resume' => array(
				'title'        => esc_html__( 'CV/Resume', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/resume/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/resume/' ),
			),

			'product-designer' => array(
				'title'        => esc_html__( 'Product Designer', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/product-designer/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/product-designer/' ),
			),

			'consultant-financial' => array(
				'title'        => esc_html__( 'Consultant Financial', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/consultant-financial/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/consultant-financial/' ),
			),

			'gym' => array(
				'title'        => esc_html__( 'GYM', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/gym/sc.webp',
				'category'     => [ 'Personal'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/gym/' ),
			),

			'cleaning-service' => array(
				'title'        => esc_html__( 'Cleaning Service', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/cleaning-service/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/cleaning-service/' ),
			),

			'car-repairing-service' => array(
				'title'        => esc_html__( 'Car Repairing Service', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/car-repairing-service/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/car-repairing-service/' ),
			),

			'laundry' => array(
				'title'        => esc_html__( 'Laundry Service', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/laundry/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/laundry/' ),
			),

			'human-resource' => array(
				'title'        => esc_html__( 'Human Resource', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/human-resource/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/human-resource/' ),
			),

			'classic-construction' => array(
				'title'        => esc_html__( 'Classic Construction', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/classic-construction/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/classic-construction/' ),
			),

			'modern-construction' => array(
				'title'        => esc_html__( 'Modern Construction', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/modern-construction/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/modern-construction/' ),
			),

			'modern-construction-2' => array(
				'title'        => esc_html__( 'Modern Construction 02', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/modern-construction-2/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/modern-construction-2/' ),
			),

			'corporate-consultant' => array(
				'title'        => esc_html__( 'Corporate Consultant', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/corporate-consultant/sc.webp',
				'category'     => [ 'Business'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/corporate-consultant/' ),
			),

			'charity' => array(
				'title'        => esc_html__( 'Charity', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/charity/sc.webp',
				'category'     => [ 'Business','Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/charity/' ),
			),

			'charity-2' => array(
				'title'        => esc_html__( 'Charity 02', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/charity-2/sc.webp',
				'category'     => [ 'Business','Agency'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/charity-two/' ),
			),

			'creative-agency-rtl' => array(
				'title'        => esc_html__( 'Creative Agency RTL', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/creative-agency-rtl/sc.webp',
				'category'     => [ 'RTL Demo'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/creative-agency-rtl/' ),
			),

			'fashion-designer-rtl' => array(
				'title'        => esc_html__( 'Fashion Designer RTL', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/fashion-designer-rtl/sc.webp',
				'category'     => [ 'RTL Demo'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/fashion-designer-rtl/' ),
			),

			'doctor-rtl' => array(
				'title'        => esc_html__( 'Doctor RTL', 'helo-essential' ),
				'screenshot'   => esc_url( $demo_content_installer ) . '/doctor-rtl/sc.webp',
				'category'     => [ 'RTL Demo'],
				'preview_link' => esc_url( 'https://crowdytheme.com/wp/helo/doctor-rtl/' ),
			),

		);

		$download_url = esc_url( $demo_content_installer ) . '/download.php';
		try {
			foreach ( $demos_array as $id => $data ) {
				$demo		 = new \FW_Ext_Backups_Demo( $id, 'piecemeal', array(
					'url'		 => $download_url,
					'file_id'	 => $id,
				) );
				$category = isset($data[ 'category' ]) ? $data[ 'category' ] : [];
				$demo->set_title( $data[ 'title' ] );
				$demo->set_screenshot( $data[ 'screenshot' ] );
				$demo->set_preview_link( $data[ 'preview_link' ] );
				$demo->set_category( $category );
				$demos[ $demo->get_id() ]	 = $demo;
				unset( $demo );
			}
		} catch (\Exception $e) {

		}


		return $demos;
	}

	public function success(){

		foreach($this->_metas as $key) {
			$value = get_user_meta(1, $key, true);
			update_option( $key, $value );
		}
		
	}

}

new Wcf_Theme_Demos();




