<?php if ( ! defined( 'ABSPATH' ) ) {
	die( 'Direct access forbidden.' );
}

/**
 * social widget
 */
class Helo_Theme_Social extends WP_Widget {

	function __construct() {
		$widget_opt = array(
			'classname'   => 'joya-widget',
			'description' => esc_html__( 'Helo social media', 'helo-essential' )
		);

		parent::__construct( 'joya-social', esc_html__( 'Helo Social Media', 'helo-essential' ), $widget_opt );
	}

	function widget( $args, $instance ) {
		global $wp_query;

		echo wp_kses_post( $args['before_widget'] );
		if ( ! empty( $instance['title'] ) ) {

			echo wp_kses_post( $args['before_title'] ) . apply_filters( 'widget_title', $instance['title'] ) . wp_kses_post( $args['after_title'] );
		}

		$facebook         = '';
		$twitter          = '';
		$dribble          = '';
		$pinterest        = '';
		$youtube          = '';
		$linkedin         = '';
		$behance          = '';
		$social_alignment = 'Center';

		if ( isset( $instance['facebook'] ) ) {
			$facebook = $instance['facebook'];
		}
		if ( isset( $instance['twitter'] ) ) {
			$twitter = $instance['twitter'];
		}
		if ( isset( $instance['dribble'] ) ) {
			$dribble = $instance['dribble'];
		}
		if ( isset( $instance['pinterest'] ) ) {
			$pinterest = $instance['pinterest'];
		}
		if ( isset( $instance['youtube'] ) ) {
			$youtube = $instance['youtube'];
		}
		if ( isset( $instance['linkedin'] ) ) {
			$linkedin = $instance['linkedin'];
		}
		if ( isset( $instance['behance'] ) ) {
			$behance = $instance['behance'];
		}

		if ( isset( $instance['social_alignment'] ) ) {
			$social_alignment = $instance['social_alignment'];
		}
		?>
        <div class="footer-social">
            <ul class="social-media">

				<?php if ( $facebook != '' ): ?>
                    <li><a href="<?php echo esc_url( $facebook ); ?>"><i class="wcf-icon icon-wcf-facebook"></i>
                            <span class="screen-reader-text"><?php echo esc_html__('Facebook Icon', 'helo-essential'); ?></span>
                        </a>
                    </li>
				<?php endif; ?>

				<?php if ( $twitter != '' ): ?>
                    <li><a href="<?php echo esc_url( $twitter ); ?>"><i class="wcf-icon icon-wcf-twitter"></i>
                            <span class="screen-reader-text"><?php echo esc_html__('Twitter Icon', 'helo-essential'); ?></span>
                        </a></li>
				<?php endif; ?>

				<?php if ( $dribble != '' ): ?>
                    <li><a href="<?php echo esc_url( $dribble ); ?>"><i class="wcf-icon icon-wcf-dribbble"></i>
                            <span class="screen-reader-text"><?php echo esc_html__('Dribble Icon', 'helo-essential'); ?></span></a></li>
				<?php endif; ?>

				<?php if ( $pinterest != '' ): ?>
                    <li><a href="<?php echo esc_url( $pinterest ); ?>"><i class="wcf-icon icon-wcf-pinterest"></i>
                            <span class="screen-reader-text"><?php echo esc_html__('Pinterest Icon', 'helo-essential'); ?></span></a>
                    </li>
				<?php endif; ?>

				<?php if ( $youtube != '' ): ?>
                    <li><a href="<?php echo esc_url( $youtube ); ?>"><i class="wcf-icon icon-wcf-instragram"></i>
                            <span class="screen-reader-text"><?php echo esc_html__('Instagram Icon', 'helo-essential'); ?></span></a>
                    </li>
				<?php endif; ?>

				<?php if ( $linkedin != '' ): ?>
                    <li><a href="<?php echo esc_url( $linkedin ); ?>"><i class="wcf-icon icon-wcf-linkdin"></i>
                            <span class="screen-reader-text"><?php echo esc_html__('Linkedin Icon', 'helo-essential'); ?></span></a></li>
				<?php endif; ?>
				<?php if ( $behance != '' ): ?>
                    <li><a href="<?php echo esc_url( $behance ); ?>"><i class="wcf-icon icon-wcf-behance"></i>
                            <span class="screen-reader-text"><?php echo esc_html__('Behance Icon', 'helo-essential'); ?></span></a></li>
				<?php endif; ?>
            </ul>
        </div><!-- Footer social end -->

		<?php
		echo wp_kses_post( $args['after_widget'] );
	}

	function update( $old_instance, $new_instance ) {
		$new_instance['title']            = strip_tags( $old_instance['title'] );
		$new_instance['facebook']         = $old_instance['facebook'];
		$new_instance['twitter']          = $old_instance['twitter'];
		$new_instance['dribble']          = $old_instance['dribble'];
		$new_instance['pinterest']        = $old_instance['pinterest'];
		$new_instance['youtube']          = $old_instance['youtube'];
		$new_instance['linkedin']         = $old_instance['linkedin'];
		$new_instance['behance']          = $old_instance['behance'];
		$new_instance['social_alignment'] = $old_instance['social_alignment'];

		return $new_instance;
	}

	function form( $instance ) {
		if ( isset( $instance['title'] ) ) {
			$title = $instance['title'];
		} else {
			$title = esc_html__( 'Social', 'helo-essential' );
		}

		$facebook         = '';
		$twitter          = '';
		$dribble          = '';
		$pinterest        = '';
		$youtube          = '';
		$linkedin         = '';
		$behance          = '';
		$social_alignment = 'Center';

		if ( isset( $instance['facebook'] ) ) {
			$facebook = $instance['facebook'];
		}
		if ( isset( $instance['twitter'] ) ) {
			$twitter = $instance['twitter'];
		}
		if ( isset( $instance['dribble'] ) ) {
			$dribble = $instance['dribble'];
		}
		if ( isset( $instance['pinterest'] ) ) {
			$pinterest = $instance['pinterest'];
		}
		if ( isset( $instance['youtube'] ) ) {
			$youtube = $instance['youtube'];
		}
		if ( isset( $instance['linkedin'] ) ) {
			$linkedin = $instance['linkedin'];
		}
		if ( isset( $instance['behance'] ) ) {
			$behance = $instance['behance'];
		}
		if ( isset( $instance['social_alignment'] ) ) {
			$social_alignment = $instance['social_alignment'];
		}
		?>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php esc_html_e( 'Title:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $title ); ?>"/>
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'facebook' ) ); ?>"><?php esc_html_e( 'Facebook:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'facebook' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'facebook' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $facebook ); ?>"/>
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'twitter' ) ); ?>"><?php esc_html_e( 'Twitter:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'twitter' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'twitter' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $twitter ); ?>"/>
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'dribble' ) ); ?>"><?php esc_html_e( 'Dribble Plus:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'dribble' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'dribble' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $dribble ); ?>"/>
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'pinterest' ) ); ?>"><?php esc_html_e( 'Pinterest:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'pinterest' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'pinterest' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $pinterest ); ?>"/>
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'youtube' ) ); ?>"><?php esc_html_e( 'Instagram:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'youtube' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'youtube' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $youtube ); ?>"/>
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'linkedin' ) ); ?>"><?php esc_html_e( 'Linkedin:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'linkedin' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'linkedin' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $linkedin ); ?>"/>
        </p>
        <p>
            <label for="<?php echo esc_attr( $this->get_field_id( 'behance' ) ); ?>"><?php esc_html_e( 'behance:', 'helo-essential' ); ?></label>
            <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'behance' ) ); ?>"
                   name="<?php echo esc_attr( $this->get_field_name( 'behance' ) ); ?>" type="text"
                   value="<?php echo esc_attr( $behance ); ?>"/>
        </p>
		<?php
	}

}
