<?php

namespace helo\Core;

/**
 * Enqueue.
 */
class Enqueue {

	/**
	 * register default hooks and actions for WordPress
	 * @return
	 */
	public function register() {
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
	}

	public function enqueue_scripts() {

		// stylesheets
		wp_register_style( 'wcf-custom-icons', HELO_CSS . '/custom-icons.min.css', null, HELO_VERSION );
		// ::::::::::::::::::::::::::::::::::::::::::
		if ( ! is_admin() ) {

			// 3rd party css
			if ( ! helo_option( 'disabled_theme_font', false ) ) {
				wp_enqueue_style( 'helo-fonts', helo_google_fonts_url( [
					'DM Sans:300,400;500,600,700,800,900',
					'PT Serif:400;500,600,700'
				] ), null, HELO_VERSION );
			}

			// Theme style
			wp_enqueue_style( 'helo-style', HELO_CSS . '/master.css', null, HELO_VERSION );
			if(
				class_exists('WooCommerce')
			){
				wp_enqueue_style( 'helo-woo', HELO_CSS . '/woo.css', null, HELO_VERSION );
			}
			wp_enqueue_style( 'wcf-custom-icons' );

		}

		// javascripts
		// :::::::::::::::::::::::::::::::::::::::::::::::
		if ( ! is_admin() ) {

			// theme scripts			
			wp_enqueue_script( 'helo-script', HELO_JS . '/script.min.js', array( 'jquery' ), HELO_VERSION, true );

			$helo_data = apply_filters( 'helo/script/custom/data', [
				'ajax_url' => admin_url( 'admin-ajax.php' ),
			] );

			wp_localize_script( 'helo-script', 'helo_obj', $helo_data );

			// Load WordPress Comment js
			if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
				wp_enqueue_script( 'comment-reply' );
			}

		}
	}
}
