<?php
// Includes the files needed for the theme updater
if ( ! class_exists( 'Helo_Theme_Updater_Admin' ) ) {
	include dirname( __FILE__ ) . '/theme-updater-admin.php';
}
$my_theme = wp_get_theme( 'helo' );
// Loads the updater classes
    new Helo_Theme_Updater_Admin(
	// Config settings
	array(
		'remote_api_url' => 'https://themecrowdy.com', // Site where EDD is hosted
		'item_name'      => 'Helo Theme', // Name of theme
		'theme_slug'     => 'helo', // Theme slug
		'version'        => $my_theme->version, // The current version of this theme
		'author'         => 'Crowdytheme', // The author of this theme
		'download_id'    => HELO_PRODUCT_ID, // Optional, used for generating a license renewal link
		'renew_url'      => '', // Optional, allows for a custom license renewal link
		'beta'           => false, // Optional, set to true to opt into beta versions
		'item_id'        => HELO_PRODUCT_ID,
	),
	// Strings
	array(
		'theme-license'             => __( 'Theme License', 'helo' ),
		'enter-key'                 => __( 'Enter your theme license key.', 'helo' ),
		'license-key'               => __( 'License Key', 'helo' ),
		'license-action'            => __( 'License Action', 'helo' ),
		'deactivate-license'        => __( 'Deactivate License', 'helo' ),
		'activate-license'          => __( 'Activate License', 'helo' ),
		'status-unknown'            => __( 'License status is unknown.', 'helo' ),
		'renew'                     => __( 'Renew?', 'helo' ),
		'unlimited'                 => __( 'unlimited', 'helo' ),
		'license-key-is-active'     => __( 'License key is active.', 'helo' ),
		/* translators: the license expiration date */
		'expires%s'                 => __( 'Expires %s.', 'helo' ),
		'expires-never'             => __( 'Lifetime License.', 'helo' ),
		/* translators: 1. the number of sites activated 2. the total number of activations allowed. */
		'%1$s/%2$-sites'            => __( 'You have %1$s / %2$s sites activated.', 'helo' ),
		'activation-limit'          => __( 'Your license key has reached its activation limit.', 'helo' ),
		/* translators: the license expiration date */
		'license-key-expired-%s'    => __( 'License key expired %s.', 'helo' ),
		'license-key-expired'       => __( 'License key has expired.', 'helo' ),
		/* translators: the license expiration date */
		'license-expired-on'        => __( 'Your license key expired on %s.', 'helo' ),
		'license-keys-do-not-match' => __( 'License keys do not match.', 'helo' ),
		'license-is-inactive'       => __( 'License is inactive.', 'helo' ),
		'license-key-is-disabled'   => __( 'License key is disabled.', 'helo' ),
		'license-key-invalid'       => __( 'Invalid license.', 'helo' ),
		'site-is-inactive'          => __( 'Site is inactive.', 'helo' ),
		/* translators: the theme name */
		'item-mismatch'             => __( 'This appears to be an invalid license key for %s.', 'helo' ),
		'license-status-unknown'    => __( 'License status is unknown.', 'helo' ),
		'update-notice'             => __( "Updating this theme will lose any customizations you have made. 'Cancel' to stop, 'OK' to update.", 'helo' ),
		'error-generic'             => __( 'An error occurred, please try again.', 'helo' ),
	)
);
