/***************************************************
 ====================  JS INDEX ====================== 
****************************************************
01. Mobile menu Start
02. Mobile offcanvas
****************************************************/

(function ($) {
  "use strict";

  // Using an object literal for a jQuery Hello Animation Theme module
  var hello_theme_module = {

    init: function (settings) {
      hello_theme_module.config = {
        responsive_menu_width: 1199,
        header: $(".default-blog-header"),
      };
      // Allow overriding the default config
      $.extend(hello_theme_module.config, settings);
      hello_theme_module.setup();
    },
    // Call all init method here
    setup: function () {
      if(document.getElementById('helo_offcanvas')) {
        hello_theme_module.offcanvas();
      }
      hello_theme_module.woo();
    },

    offcanvas: function () {
      // Get the offcanvas element and buttons
      const offcanvas = document.getElementById('helo_offcanvas');
      const openBtn = document.getElementById('helo_open_offcanvas');
      const closeBtn = document.getElementById('helo_close_offcanvas');

      // Function to open the offcanvas
      openBtn.addEventListener('click', () => {
        offcanvas.classList.add('show');
      });

      // Function to close the offcanvas
      closeBtn.addEventListener('click', () => {
        offcanvas.classList.remove('show');
      });

      // Close offcanvas when clicking outside of it
      document.addEventListener('click', (event) => {
        const isClickInside = offcanvas.contains(event.target) || openBtn.contains(event.target);
        if (!isClickInside) {
          offcanvas.classList.remove('show');
        }
      });
      
        // Get all menu items with potential submenus
        const menuItems = document.querySelectorAll('.helo-mb-menu-items li > a');
        
        // Loop through each menu item to add click event listener
        menuItems.forEach(menuItem => {
            const default_icon = menuItem.nextElementSibling;
              if (default_icon && default_icon.tagName === 'UL' && default_icon.classList.contains('dp-menu')) {
                  menuItem.querySelector('.nav-direction-icon').setAttribute('data-icon', '+');                    
              
          
                  menuItem.querySelector('.nav-direction-icon').addEventListener('click', function (e) {
                  const submenu = this.parentElement.nextElementSibling; // Get the next sibling, which should be the submenu <ul>
                  
                  // Check if this next sibling is a submenu (<ul>)
                  if (submenu && submenu.tagName === 'UL' && submenu.classList.contains('dp-menu')) {
                      e.preventDefault(); // Prevent the default link behavior (navigating)
              
                      // Toggle aria-expanded attribute for accessibility
                      const expanded = submenu.getAttribute('aria-expanded') === 'true';
                      submenu.setAttribute('aria-expanded', !expanded);
              
                      // Toggle the display of the submenu (open/close)
                      submenu.style.display = expanded ? 'none' : 'block';
                      submenu.style.opacity = expanded ? 0 :1;
              
                      // Toggle + or - symbol
                      if (expanded) {
                      this.setAttribute('data-icon', '+');
                      } else {
                      this.setAttribute('data-icon', '-');
                      }
                  }
                  });
              }
        });

    },

    woo: function(){
      let qty =  0;
      let input = null;
      $(document).on('click', '.quantity .plus', function(){
        input = $(this).parents('.quantity').find('input');
        qty = parseInt( input.val() );
        input.val(++qty);
        jQuery( "[name='update_cart']" ).prop('disabled', false);
        if(arolax_obj.cart_update_qty_change){
          jQuery( "[name='update_cart']" ).trigger( "click" );
        }

      });
      $(document).on('click', '.quantity .minus', function(){
        input = $(this).parents('.quantity').find('input');
        qty = parseInt( input.val() );
        qty = --qty;
        if(qty === 0){
          qty = 1;
        }
        input.val(qty);
        jQuery( "[name='update_cart']" ).prop('disabled', false);
        if(arolax_obj.cart_update_qty_change){
          jQuery( "[name='update_cart']" ).trigger( "click" );
        }


      });
    }

  };
  $(document).ready(hello_theme_module.init);

})(jQuery);






