<?php

/*----------------------------------------------------
SHORTHAND CONTANTS FOR THEME VERSION
-----------------------------------------------------*/
if ( site_url() === 'http://localhost:8080/development' ) {
    define( 'HELO_VERSION', time() );
} else {
    define( 'HELO_VERSION', 2.0 );    
}

/*----------------------------------------------------
SHORTHAND CONTANTS FOR THEME ASSETS URL
-----------------------------------------------------*/
define( 'HELO_THEME_URI', get_template_directory_uri() );
define( 'HELO_ASSETS', HELO_THEME_URI . '/assets/' );
define( 'HELO_IMG', HELO_THEME_URI . '/assets/imgs' );
define( 'HELO_CSS', HELO_THEME_URI . '/assets/css' );
define( 'HELO_JS', HELO_THEME_URI . '/assets/js' );

/*----------------------------------------------------
SHORTHAND CONTANTS FOR THEME ASSETS DIRECTORY PATH
-----------------------------------------------------*/
define( 'HELO_DIR', get_template_directory() );
define( 'HELO_IMG_DIR', HELO_DIR . '/assets/imgs' );
define( 'HELO_CSS_DIR', HELO_DIR . '/assets/css' );
define( 'HELO_JS_DIR', HELO_DIR . '/assets/js' );

if ( ! defined( 'HELO_PRODUCT_DOMAIN' ) ) {
    define( 'HELO_PRODUCT_DOMAIN', 'https://themecrowdy.com/' );
}
if ( ! defined( 'HELO_PRODUCT_ID' ) ) {
    define( 'HELO_PRODUCT_ID', '135' );
}

/*----------------------------------------------------
LOAD Classes
-----------------------------------------------------*/
if ( file_exists( dirname( __FILE__ ) . '/app/loader.php' ) ):
    require_once dirname( __FILE__ ) . '/app/loader.php';    
endif;
/*----------------------------------------------------
SET UP THE CONTENT WIDTH VALUE BASED ON THE THEME'S DESIGN
-----------------------------------------------------*/
if ( !isset( $content_width ) ) {
    $content_width = 800;
}

add_theme_support('custom-logo');

add_filter( 'use_block_editor_for_post', '__return_false' );

// Disable Gutenberg for widgets.
add_filter( 'use_widgets_block_editor', '__return_false' );


//Woocommerce Supports
function helo_add_woocommerce_support() {
	add_theme_support( 'woocommerce', array(
		'thumbnail_image_width' => 150,
		'single_image_width'    => 300,
		'product_grid'          => array(
			'default_rows'    => 3,
			'min_rows'        => 2,
			'max_rows'        => 8,
			'default_columns' => 4,
			'min_columns'     => 2,
			'max_columns'     => 5,
		),
	) );

	add_theme_support( 'wc-product-gallery-zoom' );
	add_theme_support( 'wc-product-gallery-lightbox' );
	add_theme_support( 'wc-product-gallery-slider' );


}

add_action( 'after_setup_theme', 'helo_add_woocommerce_support' );








